//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "fakefrac_Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
        init();
        Timer1->Enabled = !Timer1->Enabled;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
        side = 6;
        width = Image1->Width / side;
        height = Image1->Height / side;

        points = new double*[width];
        points2 = new double*[width];
        ds = new double*[width];
        for (int n = 0; n < width; n++)
        {
                points[n] = new double[height];
                points2[n] = new double[height];
                ds[n] = new double[height];
        }
        flipVal = 1000;
        constant = 10;
}
//---------------------------------------------------------------------------
void TForm1::init()
{
        for (int n = 0; n < width; n++)
        {
                for (int m = 0; m < height; m++)
                {
                        points[n][m] = (float)(rand() % 100) / 100.0;
                        ds[n][m] = 1;
                }
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
        updateValues();
        getExtremes(min, max);
        range = max - min;
        draw();
}
//---------------------------------------------------------------------------
void TForm1::getExtremes(double & max, double & min)
{
        max = 0;
        min = 0;
        for (int n = 0; n < width; n++)
        {
                for (int m = 0; m < height; m++)
                {
                        if (points[n][m] > max)
                        {
                                max = points[n][m];
                        }
                        if (points[n][m] < min)
                        {
                                min = points[n][m];
                        }
                }
        }
}
//---------------------------------------------------------------------------
void TForm1::updateValues()
{
        for (int n = 0; n < width; n++)
        {
                for (int m = 0; m < height; m++)
                {
                        double
                                sum = 0;
                        for (int dn = 0; dn <= 1; dn++)
                        {
                                for (int dm = 0; dm <= 1; dm++)
                                {
                                        int
                                                din = n - 1 + 2 * dn,
                                                dim = m - 1 + 2 * dm;
                                        if (din < 0)
                                        {
                                                din = width - 1;
                                        }
                                        if (din >= width)
                                        {
                                                din = 0;
                                        }
                                        if (dim < 0)
                                        {
                                                dim = height - 1;
                                        }
                                        if (dim >= height)
                                        {
                                                dim = 0;
                                        }
                                        sum += ds[din][dim] * points[din][dim];
                                        if (sum > flipVal || sum < 0)
                                        {
                                                ds[din][dim] *= -1;
                                        }
                                }
                        }
                        if (!CBFlow->Checked)
                        {
                                points[n][m] += 0.25 * sum + constant;
                        }
                        else
                        {
                                points[n][m] = 0.25 * sum + constant;
                        }
                }
        }
}
//---------------------------------------------------------------------------
void TForm1::draw()
{
        for (int n = 1; n < width - 1; n++)
        {
                for (int m = 1; m < height - 1; m++)
                {
                        Image1->Canvas->Brush->Color = getColor2(points[n][m], min, range);
                        Image1->Canvas->FillRect(Rect(n * side, m * side, n * side + side, m * side + side));
                }
        }
}
//---------------------------------------------------------------------------
void TForm1::draw2()
{
        for (int n = 1; n < width - 1; n++)
        {
                for (int m = 1; m < height - 1; m++)
                {
                        if (points[n][m] > points2[n][m])
                        {
                                Image1->Canvas->Brush->Color = getColor2(points[n][m], min, range);
                                Image1->Canvas->FillRect(Rect(n * side, m * side, n * side + side, m * side + side));
                        }
                        else
                        {
                                Image1->Canvas->Brush->Color = getColor(points2[n][m], min, range);
                                Image1->Canvas->FillRect(Rect(n * side, m * side, n * side + side, m * side + side));
                        }
                }
        }
}
//---------------------------------------------------------------------------
TColor TForm1::getColor(double val, double min, double range)
{
        int
                r = 0 * (int)(255.0 * (val - min) / range),
                g = 0 * (int)(255.0 - 255.0 * (val - min) / range),
                b = (int)(255.0 - 255.0 * (val - min) / range);
        if (g < 0)
        {
                g = 0;
        }
        AnsiString
                colString = "$" + IntToHex(r, 4) + IntToHex(g, 2) +
                        IntToHex(b, 2);
        return StringToColor(colString);
}
//---------------------------------------------------------------------------
TColor TForm1::getColor2(double val, double min, double range)
{
        int
                r = 0 * (int)(255.0 - 255.0 * (val - min) / range),
                g = (int)(255.0 - 255.0 * (val - min) / range),
                b = 0 * (int)(255.0 - 255.0 * (val - min) / range);
        if (g < 0)
        {
                g = 0;
        }
        AnsiString
                colString = "$" + IntToHex(r, 4) + IntToHex(g, 2) +
                        IntToHex(b, 2);
        return StringToColor(colString);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer2Timer(TObject *Sender)
{
        CBFlow->Checked = !CBFlow->Checked;
        if (CBFlow->Checked)
        {
                Timer2->Interval = 30000;
        }
        else
        {
                Timer2->Interval = 900;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button2Click(TObject *Sender)
{
        Timer2->Enabled = !Timer2->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
        init2();
        Timer3->Enabled = !Timer3->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer3Timer(TObject *Sender)
{
        adjustValues2();
        getExtremes(min, max);
        range = max - min;
        draw();
}
//---------------------------------------------------------------------------
void TForm1::init2()
{
        for (int n = 0; n < width; n++)
        {
                for (int m = 0; m < height; m++)
                {
                        points[n][m] = (float)(rand() % 10) / 10.0;
                        points2[n][m] = (float)(rand() % 10) / 10.0;
                        ds[n][m] = 1;
                }
        }
        points[width / 2][height / 2] = 0;
        points2[width / 2][height / 2] = 0;
}
//---------------------------------------------------------------------------
void TForm1::adjustValues2()
{
        recurse(width / 2, height / 2, StrToInt(eMaxLength->Text));
}
//---------------------------------------------------------------------------
void TForm1::recurse(int row, int column, int maxLength)
{
        if (maxLength <= 0 || row < 0 || row >= width || column < 0 || column >= height)
        {
                return;
        }
        points[row][column] += ds[row][column];
        if (points[row][column] < 0 || points[row][column] >= flipVal)
        {
                ds[row][column] *= -1;
        }
        int
                rNext = row -1 + rand() % 3,
                cNext = column -1 + rand() % 3;
        recurse(rNext, cNext, maxLength - 1);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
        init2();
        lineRow = width / 2;
        lineColumn = height / 2;
        lineRow2 = width / 4;
        lineColumn2 = height / 4;
        Timer4->Enabled = !Timer4->Enabled;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Timer4Timer(TObject *Sender)
{
        fade();
        adjustValues3();
        getExtremes(min, max);
        range = max - min;
        draw2();
}
//---------------------------------------------------------------------------
void TForm1::adjustValues3()
{
        float
                rc = 2.0 * M_PI * (float)(rand() % 10) / 10.0;
        recurse2(lineRow, lineColumn, StrToInt(eMaxLength->Text), rc);
        recurse22(lineRow2, lineColumn2, StrToInt(eMaxLength->Text), rc);
}
//---------------------------------------------------------------------------
void TForm1::recurse2(int &row, int &column, int maxLength, float rc)
{
        if (maxLength <= 0 || row < 0 || row >= width || column < 0 || column >= height)
        {
                return;
        }
        points[row][column] += ds[row][column];
        if (points[row][column] < 0)
        {
                points[row][column] = 0;
        }
        if (points[row][column] >= flipVal)
        {
                points[row][column] = flipVal;
        }
        rc = rc - 0.5 * M_PI  + 1.0 * M_PI * (float)(rand() % 10) / 10.0;
        float
                val = 1;
        if (fabs(cos(rc)) < 0.5)
        {
                val = 0;
        }
        if (cos(rc) < 0)
        {
                val *= -1;
        }
        row += val;
        if (row < 0)
        {
                row += width;
        }
        row %= width;
        val = 1;
        if (fabs(sin(rc)) < 0.5)
        {
                val = 0;
        }
        if (sin(rc) < 0)
        {
                val *= -1;
        }
        column += val;
        if (column < 0)
        {
                column += height;
        }
        column %= height;
        recurse2(row, column, maxLength - 1, rc);
}
//---------------------------------------------------------------------------
void TForm1::recurse22(int &row, int &column, int maxLength, float rc)
{
        if (maxLength <= 0 || row < 0 || row >= width || column < 0 || column >= height)
        {
                return;
        }
        points2[row][column] += ds[row][column];
        if (points2[row][column] < 0)
        {
                points2[row][column] = 0;
        }
        if (points2[row][column] >= flipVal)
        {
                points2[row][column] = flipVal;
        }
        rc = rc - 0.5 * M_PI  + 1.0 * M_PI * (float)(rand() % 10) / 10.0;
        float
                val = 1;
        if (fabs(cos(rc)) < 0.5)
        {
                val = 0;
        }
        if (cos(rc) < 0)
        {
                val *= -1;
        }
        row += val;
        if (row < 0)
        {
                row += width;
        }
        row %= width;
        val = 1;
        if (fabs(sin(rc)) < 0.5)
        {
                val = 0;
        }
        if (sin(rc) < 0)
        {
                val *= -1;
        }
        column += val;
        if (column < 0)
        {
                column += height;
        }
        column %= height;
        recurse2(row, column, maxLength - 1, rc);
}
//---------------------------------------------------------------------------
void TForm1::fade()
{
        for (int n = 0; n < width; n++)
        {
                for (int m = 0; m < height; m++)
                {
                        points[n][m] /= 2.0;
                        points2[n][m] /= 2.0;
                }
        }
}
//---------------------------------------------------------------------------

